// -*- C++ -*-
//
// Package:     Arich
// Module:	
//
// Description: 
//
// Usage:
//      [class and public member function
//       documentation goes here]
//
// Author:      R. Pestotnik
// Created:     Thu May  1 00:00:01 EST 2003
// $Id$
//
// Revision history
//
// $Log$



#ifdef DLLMAIN
#define DLLEXPORT  __declspec(dllexport)
#else 
#define DLLEXPORT  //
#endif

#include <stdlib.h>
#include <stdio.h>
#ifdef WIN32
#define VISUAL_CPLUSPLUS 1
#else
#define f2cFortran
#include <string.h>
#endif


DLLEXPORT
void Hbname ( int id , char  * block, int * variable, char *form )
{  
#ifdef WIN32
  extern void __stdcall HBNAME(  int * A1  , char * A2 , unsigned B2 , 
				 void *A3  , char * A4 , unsigned B4 );
  
  HBNAME(&id, block ,strlen(block), variable,form, strlen(form) );
#else
  extern void hbname_(int *, char *, void *, char *, int, int); 
  hbname_(&id, block, variable,form ,strlen(block), strlen(form) );
#endif
}

DLLEXPORT
void Rzsave(void)
{
#ifdef WIN32
  extern void __stdcall RZSAVE(void);
  RZSAVE();
#else
  extern void rzsave_(void); 
  rzsave_();
#endif
 }  


#include "cfortran.h"
#ifdef WIN32
#include "hbook_win.h"
#else
#include "hbook.h"
#endif

#ifndef FALSE
#define FALSE 0
#endif

#define PAWC_SIZE 500000

typedef struct { float PAW[PAWC_SIZE]; } PAWC_DEF;
#define PAWC COMMON_BLOCK(PAWC,pawc)
COMMON_BLOCK_DEF(PAWC_DEF,PAWC);
PAWC_DEF PAWC;


DLLEXPORT
void Hlimit(int size)
{
 HLIMIT(size);
}

DLLEXPORT
void Hcdir(char *path, char *opt)
{
  HCDIR(path, opt);
}

DLLEXPORT
void Hmdir(char *dir, char *opt)
{
  HMDIR(dir, opt);
}

DLLEXPORT
void Hldir(char *path, char *opt)
{
  HLDIR(path, opt);
}

DLLEXPORT
void Hropen(int lun, char *top, char *file, char *opt, int * lrec ,int *istat)
{
 int llrec=*lrec;
 int iistat;
 HROPEN(lun,top,file,opt,llrec,iistat);
 *lrec=llrec;
 *istat=iistat;
}

/*
DLLEXPORT
void Hbookn(int id, char *title,int nvar,char *rzpath,int nwbuff,char *tags)
{
  HBOOKN(id,title,nvar,rzpath,nwbuff,tags);
}
*/


DLLEXPORT
void Hbook1(int id, char * chtitl,int nx,float xmi, float xma, float vmx )
{
HBOOK1( id, chtitl,nx, xmi, xma, vmx );
}

DLLEXPORT
void Hbook2(int id, char * chtitl,int nx,float xmi, float xma,int ny, float ymi, float yma, float vmx )
{
HBOOK2( id, chtitl,nx, xmi, xma, ny, ymi, yma, vmx );
}

DLLEXPORT
void Hbprof(int id, char * chtitl,int nx,float xmi, float xma, float ymi, float yma,char * chopt  )
{
HBPROF( id, chtitl,nx, xmi, xma, ymi, yma, chopt );
}


DLLEXPORT
void Hfill( int id, float x, float y, float w)
{
  HFILL(id,x,y,w);
}

DLLEXPORT
void Hprint(int id)
{
  HPRINT(id);
}

DLLEXPORT
void Hcopy(int id1,int id2, char *title)
{
  HCOPY(id1,id2,title);
}

DLLEXPORT
void Hdelet(int id)
{
  HDELET(id);
}

DLLEXPORT
void Hbnt(int id,char* titl, char *opt)
{
  HBNT(id,titl,opt);
}

DLLEXPORT
void Hfnt (int id)
{
  HFNT(id);
}

DLLEXPORT
void Hfntb (int id, char*chblock)
{
  HFNTB(id,chblock);
}

DLLEXPORT
void Hfn (int id,float *x)
{
  HFN(id,x);
}

DLLEXPORT
void Hpak (int id,float *x)
{
  Hpak(id,x);
}


DLLEXPORT
void Hf1 ( int id, float x, float w )
{
  HF1(id,x,w);
}

DLLEXPORT
void Hf2  ( int id, float x, float y,float w )
{
  HF2(id,x,y,w);
}


DLLEXPORT
void Hbnameold ( int id , char  * block, int * variable, char *form )
{ 
  HBNAME (id, block ,variable,form);
}

/*

DLLEXPORT
void Hbnamc( int id , char * block, char * variable, char *form )
{
  HBNAMC (id,block,variable,form);
}


*/

#ifdef WIN32

DLLEXPORT
void Hbooknc(int id, char *title,int nvar,char *block,float *tuple,char *tags)
{
  HBOOKNC(id,title,nvar,block,tuple,tags);
}


DLLEXPORT
void Hnform( char *chform , char * chname, int * ldim, char *chtype,float *xlow, float *xhigh)
{
  HNFORM (chform,chname,ldim,chtype,xlow,xhigh);
}


#endif
DLLEXPORT
void Hprnt( int id )
{
  HPRNT(id);
}

DLLEXPORT
void Hrout(int id,int *icycle,char *opt)
{
  int iicycle=*icycle;
  HROUT(id,iicycle,opt);
  *icycle=iicycle;
}

DLLEXPORT
void Hrend(char *top)
{
  HREND(top);
}

DLLEXPORT
void Hnoent(int id,int * noent)
{
  int dum=0;
  HNOENT(id,dum);
  *noent=dum;
}           

