#ifndef KEY_MAN_C_H
#define KEY_MAN_C_H

#define FTNLEN short

void open_inkey_ ();
void close_inkey_ ();
void wait_input_ (int *inunit, int* waskey, int 
*testkey);
void key_ready_ (int *waskey);
void wait_key_ ();
int  my_getc_ (char *ch_read, FTNLEN ch_len);

/*
**- SUBROUTINE WAIT_INPUT(INUNIT,WASKEY,TESTKEY)
**- waits for the input on the INUNIT or standard input (if 
TESTKEY=.TRUE.)
**- to become available. WASKEY is true if key was pressed.
**- input parameters:   inunit<i> : c unit number
**-                     testkey<l> : wait for standard input too ?
**- output parameters : waskey<l> : was key pressed ?
*/
/*
**- SUBROUTINE KEY_READY(WASKEY)
**- checks is standar input is available
**- output parameters : waskey<l> : was key pressed ?
*/ 
/*
**- SUBROUTINE WAIT_KEY()
**- waits for standar input to become available
*/
/*  
**- INTEGER FUNCTION MY_GETC(CH_READ)
**- get next character from standar input. function returns
**- -1 , CH_READ=CHAR(0) if input empty
**-  0 , CH_READ if input not empty
**- output parameters : ch_read<c1> : input character
*/


#endif
